%global pypi_name PyQt-builder
%global srcname pyqt_builder

Name:           python%{python3_pkgversion}-%{pypi_name}
Version:        1.17.1
Release:        1%{?dist}
Summary:        The PEP 517 compliant PyQt build system

License:        GPLv2 or GPLv3
URL:            https://www.riverbankcomputing.com/software/pyqt/
# download manually from https://pypi.org/project/PyQt-builder/
Source0:        %{srcname}-%{version}.tar.gz
#{pypi_source}
BuildArch:      noarch

BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}dist(setuptools) >= 64.0
BuildRequires:  python%{python3_pkgversion}-setuptools_scm

%description
PyQt-builder is the PEP 517 compliant build system for PyQt and projects that
extend PyQt. It extends the sip build system and uses Qt's qmake to perform the
actual compilation and installation of extension modules.Projects that use
PyQt- builder provide an appropriate pyproject.toml file and an optional
project.py.

%prep
%autosetup -p1 -n %{srcname}-%{version}


%build
%pyproject_wheel

%install
%pyproject_install


%files
%license LICENSE
%{_bindir}/pyqt-bundle
%{_bindir}/pyqt-qt-wheel
%{python3_sitelib}/pyqtbuild
%{python3_sitelib}/PyQt_builder*-info

%changelog
* Fri Jan  3 2025 Raven <raven@sysadmins.ws> - 1.17.1-1
- Update to new upstream release 1.17.1

* Tue Dec 19 2023 Raven <raven@sysadmins.ws> - 1.15.3-1
- Update to new upstream release 1.15.3

* Fri Aug 25 2023 Raven <raven@sysadmins.ws> - 1.14.1-1
- Update to new upstream release 1.14.1

* Wed Jul 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.13.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Wed Jul 20 2022 Scott Talbert <swt@techie.net> - 1.13.0-1
- Update to new upstream release 1.13.0 (#2098289)

* Mon Jun 13 2022 Python Maint <python-maint@redhat.com> - 1.12.2-3
- Rebuilt for Python 3.11

* Wed Jan 19 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.12.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Sat Oct 30 2021 Scott Talbert <swt@techie.net> - 1.12.2-1
- Update to new upstream release 1.12.2 (#2018190)

* Tue Oct 12 2021 Scott Talbert <swt@techie.net> - 1.12.1-1
- Update to new upstream release 1.12.1 (#2013246)

* Mon Oct 04 2021 Scott Talbert <swt@techie.net> - 1.11.0-1
- Update to new upstream release (#2010060)

* Fri Sep 24 2021 Scott Talbert <swt@techie.net> - 1.10.3-2
- Fix license info (#2007385)

* Wed Jul 21 2021 Scott Talbert <swt@techie.net> - 1.10.3-1
- Update to new upstream release 1.10.3 (#1984602)

* Wed Jul 21 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.10.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Fri Jun 04 2021 Python Maint <python-maint@redhat.com> - 1.10.0-2
- Rebuilt for Python 3.10

* Mon May 24 2021 Scott Talbert <swt@techie.net> - 1.10.0-1
- Update to latest upstream release; remove hard-code on sip5

* Mon Jan 25 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.6.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Tue Dec 29 2020 Kevin Fenzi <kevin@scrye.com> - 1.6.0-2
- Remove shipped dlls.

* Tue Dec 15 2020 Kevin Fenzi <kevin@scrye.com> - 1.6.0-1
- Initial package.
